/*
    MapaJS. Generator atlasów oparty o mapy z zewnętrznych źródeł.
    Copyright (C) 2009  Marcin Szewczyk, Wodny, <mapa@wodny.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

    var padding_x = 256;
    var padding_y = 256;

    var center_id_x = 452;
    var center_id_y = 934;

    var center_pos_x = 256;
    var center_pos_y = 256;

    var mode = 0;

    function resetPosition() {
      //center_id_x = 452;
      //center_id_y = 934;
      center_id_x = parseInt(document.getElementById("posStartX").value);
      center_id_y = parseInt(document.getElementById("posStartY").value);

      center_pos_x = 256;
      center_pos_y = 256;
    }

    function handleSectorClick(img) {
      switch(mode) {
        case 1:
          togglePage(img);
          break;
        default:
          toggleSector(img);
      }
    }

    function toggleSector(img) {
      var p = {x:0, y:0};
      refToXY(img, p);
      if(isFilled(p.x, p.y)) {
        if(!onlyEmptyNeigh(p.x, p.y)) {
          reemptySector(p.x, p.y);
        }
      } else {
        fillSector(p.x, p.y);
      }
    }

    /******************************/
    function addMapSector(x, y) {
      addFotoMapSector(x, y);
      fillSector(x, y);

      addOverlay(x, y);
    }

    function fillSector(x, y) {
      var img = document.getElementById(genID(x, y));
      img.setAttribute("src", genSrcByXY(x, y));
      addCross(x, y);

      addTopoMapSector(x, y);
    }

    function reemptySector(x, y) {
      reduceSector(x, y);
      reduceIfEmpty(x, y-1);
      reduceIfEmpty(x-1, y);
      reduceIfEmpty(x+1, y);
      reduceIfEmpty(x, y+1);

      removeTopoMapSector(x, y);
    }

    /******************************/

    function handleSectorOver(img) {
      switch(mode) {
        case 1:
          setPageHoverPos(img);
          break;
        default:
          break;
      }
    }

    function overToSector(div) {
      var id = div.id.split(":", 2);
      return document.getElementById(id[1]);
    }

    function handleOverlayClick(div) {
      handleSectorClick(overToSector(div));
    }

    function handleOverlayOver(div) {
      handleSectorOver(overToSector(div));
    }

    function toggleMenu() {
      var menu = document.getElementById("menu");
      if(menu.style.display == "none") {
        menu.style.display = "block";
      } else {
        menu.style.display = "none";
      }
    }

    function setMode(m) {
      mode = m;
      switch(mode) {
        case 0:
          deinitPageMode();
          break;
        case 1:
          initPageMode();
          break;
      }
    }

    function genID(x, y) {
      return x+","+y;
    }

    function idToXY(id) {
      var p = {x:0, y:0};
      var xya = id.split(",", 2);
      p.x = xya[0];
      p.y = xya[1];
      return p;
    }

    function refToXY(img, xy) {
      var id = img.id.split(":", 2);
      var pos = id[id.length-1].split(",", 2);
      xy.x = parseInt(pos[0]);
      xy.y = parseInt(pos[1]);
    }

    function genStyleByXY(x, y) {
      px = center_pos_x - (center_id_x - x) * padding_x;
      py = center_pos_y + (center_id_y - y) * padding_y;
      if(px < 0) {
        adjustMap(1, 0);
        return genStyleByXY(x, y);
      }
      if(py < 0) {
        adjustMap(0, 1);
        return genStyleByXY(x, y);
      }
      return "position: absolute; left: "+px+"px; top: "+py+"px; "+
        "width: "+padding_x+"px; height: "+padding_y+"px;";
    }

    function adjustStyle(img) {
      if(!img.style) return;
      var p = {x:0, y:0};
      refToXY(img, p);

      img.setAttribute("style", genStyleByXY(p.x, p.y));
    }

    function adjustMap(x, y) {
      center_id_x -= x;
      center_id_y += y;

      adjustChildren(getMapDiv());
      adjustChildren(getMapOverlay());
      adjustChildren(getTopoMapDiv());
      //TODO: Make new version
      adjustPages(x, y);
    }

    function adjustChildren(div) {
      if (div.hasChildNodes()) {
        var children = div.childNodes;
        for (var i = 0; i < children.length; i++) {
          adjustStyle(children[i]);
        }
      }
    }

    function alertFormatErr(d) {
      alert("Błędny format danych!\nErr @ "+d);
    }

    function startByGeoPCoords() {
      var bigX = parseInt(document.getElementById("posBigX").value);
      var bigY = parseInt(document.getElementById("posBigY").value);
      center_id_x = parseInt(bigY / 800);
      center_id_y = parseInt(bigX / 800);
      document.getElementById("posStartX").value = center_id_x;
      document.getElementById("posStartY").value = center_id_y;

      start();
    }

    function start() {
      resetPosition();

      removeAllChildren(getMapDiv());
      removeAllChildren(getMapOverlay());
      removeAllChildren(getTopoMapDiv());
      removeAllChildren(getPages());

      addMapSector(center_id_x, center_id_y);
      addCross(center_id_x, center_id_y);

      topoOpacitySet(0.25);
    }


