/*
    MapaJS. Generator atlasów oparty o mapy z zewnętrznych źródeł.
    Copyright (C) 2009  Marcin Szewczyk, Wodny, <mapa@wodny.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/




var page_size_x = 4;
var page_size_y = 6;
var page_border = 15;

function getPageHover() {
  return document.getElementById("page_hover");
}

function getPages() {
  return document.getElementById("pages");
}

function initPageMode() {
  var page = getPageHover();
  page.style.width = (padding_x * page_size_x) + "px";
  page.style.height = (padding_y * page_size_y) + "px";
  page.style.display = "block";
}

function deinitPageMode() {
  var page = getPageHover();
  page.style.display = "none";
}

function genPageHoverStyle(x, y) {
  px = center_pos_x - (center_id_x - x) * padding_x;
  py = center_pos_y + (center_id_y - y) * padding_y;
  return "position: absolute; left: "+px+"px; top: "+py+"px; display: block; "+
    "width: "+(padding_x * page_size_x)+"px; height: "+(padding_y * page_size_y)+"px";
}

function genPageStyle(x, y) {
  px = center_pos_x - (center_id_x - x) * padding_x;
  py = center_pos_y + (center_id_y - y) * padding_y;
  return "position: absolute; left: "+(px-page_border)+"px; top: "+(py-page_border)+"px; display: block; "+
    "width: "+(padding_x * page_size_x)+"px; height: "+(padding_y * page_size_y)+"px";
}

function refToPageXY(over, xy) {
  var x = parseInt(over.style.left);
  var y = parseInt(over.style.top);
  xy.x = center_id_x + (x - center_pos_x) / padding_x;
  xy.y = center_id_y - (y - center_pos_y) / padding_y
}

function refToPageID(over, xy) {
  var name_and_id = over.id.split(":", 2);
  var id = name_and_id[1].split(",", 2);
  xy.x = id[0];
  xy.y = id[1];
}


function adjustPageStyle(page) {
  if(!page.style) return;
  var p = {x:0, y:0};
  refToPageID(page, p);

  page.setAttribute("style", genPageStyle(p.x, p.y));
}

function adjustPages(x, y) {
  var div = getPages();
  if (div.hasChildNodes()) {
    var children = div.childNodes;
    for (var i = 0; i < children.length; i++) {
      adjustPageStyle(children[i]);
    }
  }
}

function setPageHoverPos(img) {
  var p = idToXY(img.id);
  var page = getPageHover();
  page.setAttribute("style", genPageHoverStyle(p.x, p.y));
}

function genPageID(x, y) {
  return "page:"+genID(x, y);
}

function pageExists(img) {
  var p = idToXY(img.id);
  var div = document.getElementById(genPageID(p.x, p.y));
  return div ? true : false;
}

function removePage(img) {
  var div = document.getElementById("page:"+img.id);
  if(!div) return;
  getPages().removeChild(div);
}

function commonPageAtts(div, x, y) {
  div.setAttribute("style", genPageStyle(x, y));
  div.setAttribute("class", "page");
  div.setAttribute("id", genPageID(x,y));
}

function addPage(img) {
  var pages = getPages();
  var div = document.createElement("div");
  var p = idToXY(img.id);
  commonPageAtts(div, p.x, p.y);
  pages.appendChild(div);
}

function addPageXY(x, y) {
  var pages = getPages();
  var div = document.createElement("div");
  commonPageAtts(div, x, y);
  pages.appendChild(div);
}

function togglePage(img) {
  if(pageExists(img)) {
    removePage(img);
  } else {
    addPage(img);
  }
}


function genListByPages() {
  var list = document.getElementById("pages_list");

  list.value = "";

  var div = getPages();
  if (div.hasChildNodes()) {
    var children = div.childNodes;
    for (var i = 0; i < children.length; i++) {
      if(isFilled_ref(children[i])) list.value += (children[i].id.split(":", 2))[1]+"\n";
    }
  }
}

function genPagesByList() {
  var text = document.getElementById("pages_list").value;

  var lines = text.split("\n");
  var xy;

  for (var i = 0; i < lines.length; i++) {
    xy = lines[i].split(",", 2);
    if(xy.length != 2) {
      alert("Błędny format danych!");
      return;
    }
    x = parseInt(xy[0]);
    y = parseInt(xy[1]);
    addPageXY(x, y);
  }
}
