/*
    MapaJS. Generator atlasów oparty o mapy z zewnętrznych źródeł.
    Copyright (C) 2009  Marcin Szewczyk, Wodny, <mapa@wodny.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/



    var href_topo_prefix = 'http://ars.geoportal.gov.pl/ARS/getTile.aspx?service=TBD&cs=EPSG2180&fileIDX=';
    var topo_opacity = 0.25;

    function genTopoSrcByXY(x, y) {
      return href_topo_prefix + "L0X" + x + "Y" + y + ".png";
    }

    function topoOpacityInc() {
      topoOpacityAdj(0.05);
    }

    function topoOpacityDec() {
      topoOpacityAdj(-0.05);
    }

    function topoOpacityAdj(i) {
      topoOpacitySet(topo_opacity + i);
    }

    function topoOpacitySet(i) {
      var topo = getTopoMapDiv();
      i = (i < 0) ? 0 : ((i > 1) ? 1 : i);
      topo_opacity = i;
      topo.style.opacity = i;
    }

    function adjustTopoSectors() {
      div = getTopoMapDiv();
      if (div.hasChildNodes()) {
        var children = div.childNodes;
        for (var i = 0; i < children.length; i++) {
          adjustStyle(children[i]);
        }
      }
    }

    function getTopoMapDiv() {
      return document.getElementById("topo_map");
    }

    function genTopoID(x, y) {
      return "topo:" + genID(x, y);
    }

    function commonTopoSectorAtts(img, x, y) {
      img.setAttribute("style", genStyleByXY(x, y));
      img.setAttribute("id", genTopoID(x, y));
      img.setAttribute("name", genTopoID(x, y));
      img.setAttribute("alt", genTopoID(x, y));
    }

    function fillTopoSector(x, y) {
      var img = document.getElementById(genTopoID(x, y));
      img.setAttribute("src", genTopoSrcByXY(x, y));
    }

    function topoSector(x, y) {
      return document.getElementById(genTopoID(x, y));
    }

    function topoSectorExists(x, y) {
      return topoSector(x, y) ? 1 : 0;
    }

    function addTopoMapSector(x, y) {
      if(topoSectorExists(x, y)) return;
      var map = getTopoMapDiv();
      var img = document.createElement("img");
      commonTopoSectorAtts(img, x, y);
      map.appendChild(img);
      fillTopoSector(x, y);
    }

    function removeTopoMapSector(x, y) {
      var sector = topoSector(x, y);
      if(!sector) return;
      var topo = getTopoMapDiv();
      topo.removeChild(sector);
    }

    function topoShow() {
      var topo = getTopoMapDiv();
      topo.style.display = 'block';
    }

    function topoHide() {
      var topo = getTopoMapDiv();
      topo.style.display = 'none';
    }
